package eu.mhsl.craftattack.core.api.client.repositories;

import com.google.common.reflect.TypeToken;
import eu.mhsl.craftattack.core.api.client.HttpRepository;
import eu.mhsl.craftattack.core.api.client.ReqResp;
import eu.mhsl.craftattack.core.util.api.WebsiteApiUtil;

import java.lang.reflect.Type;
import java.util.List;
import java.util.Map;
import java.util.UUID;

public class FeedbackRepository extends HttpRepository {
    public FeedbackRepository() {
        super(WebsiteApiUtil.getBaseUri(), WebsiteApiUtil::withAuthorizationSecret);
    }

    public record Request(String event, List<UUID> users) {
    }

    public ReqResp<Map<UUID, String>> createFeedbackUrls(Request data) {
        final Type responseType = new TypeToken<Map<UUID, String>>() {
        }.getType();
        ReqResp<Object> rawData = this.post("feedback", data, Object.class);
        return new ReqResp<>(rawData.status(), this.gson.fromJson(this.gson.toJson(rawData.data()), responseType));
    }
}
